'FFSubmenu=Tools
'FFName=Deinstallation

'FFSkriptName=Deinstallation.vbs
'FFSkriptArchiv=Deinstallation.zip
'FFSkriptDirectory=
'FFSkriptFiles=
'FFScriptProfile=

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.03
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

'(c) Harald Maeckler, Dsseldorf 2011

' ********************************************************************
' Deinstallation.vbs (Script fr FixFoto)
' Funktion:	Deinstallation von FF-Skripten
'
' Version 1.03 vom 19.07.2011	- Bug bei Auflistun der Skripte beseitigt
' Version 1.02 vom 16.11.2010	- Bug bei Abbrechen der Festlegung des
'									Sicherungsortes fr das zip-Archiv beseitigt
' Version 1.01 vom 04.07.2009	- eigene Deinstallation
' Version 1.00 vom 03.07.2009	- Betaversion
'  
'** Start Kurzbeschreibung *******************************************
' Deinstallation / Version 1.03
' =================
' Das Skript dient der Deinstallation von Skripten
' 
' In der Skriptliste werden alle installierten FixFoto-Skripte zum Lschen angeboten, auer
' dem vorliegenden Skript 'Deinstallation'.
' Man whlt aus der Liste das zu lschende Skript aus und bettigt 'Lschen'. Daraufhin wird
' angeboten, alle im Skriptverzeichnis vorhandenen zip-Archive (auer 'Deinstallation.zip')
' in einem auszuwhlendem Verzeichnis zu sichern. Anschlieend werden die Archive aus dem 
' Skriptverzeichnis entfernt.
' Das ausgewhlte Skript selbst wird im Skriptverzeichnis gelscht. Die FixFotoScript.ini wird
' bereinigt und damit die Lschroutine abgeschlossen.
'
' Weitere Skripte knnen dann ausgewhlt und gelscht werden. Mit 'Beenden' wird der Dialog
' geschlossen. Nach manueller Durchfhrung der 'Automatischen Skriptkonfiguration' ist die
' Deinstallation abgeschlossen. Alternativ kann FixFoto beendet und wieder gestartet werden.
'
' Hinweis:
' Bei der Installation oder bei der Anwendung eines Skripts angelegte Dateien und Ordner werden
' nicht gelscht. Auch eventuell in der Registry abgelegte Daten bleiben erhalten.
'
' Deinstallation des Skripts 'Deinstallation'
' ========================
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript aus 
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const SkriptName = "Deinstallation.vbs"						'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2

Dim objFS													'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")

Dim IniDatei,ListenArray,Antwort,LoeschSkript,EintragEnde,SkriptKill
SkriptKill = false

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

IniDatei = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if not objFS.FileExists(IniDatei) then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Das Skript wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'** Start Dialog Deinstallation **
FF_AddDialog "Deinstallation",146,46
FF_AddControl "Deinstallation","Skript","STATIC",10,2,15,10
FF_AddControl "Deinstallation","Skriptname","COMBO",8,12,130,10
FF_AddControl "Deinstallation","?","BUTTON",14,30,10,10
FF_AddControl "Deinstallation","Lschen","BUTTON",95,29,33,11
FF_AddControl "Deinstallation","Beenden","BUTTON",48,29,33,11
FF_AddControl "Deinstallation","&d","BUTTON",38,34,1,1
'** End Dialog Deinstallation **

call SkriptListe

FF_ActivateControl "Deinstallation","&d"

do									'Befehlsabfrage
	Select Case FF_ShowDialog ("Deinstallation")
	Case "&d"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "CANCEL","Beenden"
		exit do
	Case "Lschen"
		Abbruch = false
		LoeschSkript = FF_GetControl("Deinstallation","Skriptname")
		Antwort = msgbox ("Soll das Skript '" & LoeschSkript & "' wirklich gelscht werden?", _
						  vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			call ArchivEntfernung
			if not Abbruch then
				call Skriptentfernung
				call IniBereinigung
				LoeschSkript = FF_GetControl("Deinstallation","Skriptname")
				call SkriptListe
				msgbox 	"Nach manueller Durchfhrung der 'Automatischen Skriptkonfiguration'" & vbNewLine & _
						"ist das Skript '" & LoeschSkript & "' gelscht!" & vbNewLine & vbNewLine & _
						"Vor der Durchfhrung der 'Automatischen Skriptkonfiguration' knnen" & vbNewLine & _
						"aber auf Wunsch weitere Skripte gelscht werden." & vbNewLine & vbNewLine & _
						"Alternativ zur 'Automatischen Skriptkonfiguration' kann auch FixFoto" & vbNewLine & _
						"beendet und dann neu gestartet werden.",vbInformation,"Hinweis"
			end if
		end if
	Case Else
	End Select
loop

FF_CloseDialog ("Deinstallation")
if SkriptKill then call KillSkript	'ggf. Skript 'Deinstallation' komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub SkriptListe
Dim Zeile, tmpString,Liste,ListeMax,n

'Skriptnamen auflisten
FF_SetControl "Deinstallation","Skriptname",""
Set Zeile = objFS.OpenTextFile(IniDatei, ForReading)

do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	if instr(tmpString,"Name=") > 0 then
		tmpString = ucase(mid(tmpString,6,1)) & mid(tmpString,7)
		if tmpString <> objFS.GetBaseName(Skriptname) then			'Deinstallation.vbs ausgenommen
			Liste = Liste & "@" & tmpString
		end if
	end if
loop 
Zeile.Close

'Skriptnamen alphanumerisch sortieren
Liste = mid(Liste,2)
ListenArray = split(Liste,"@")
ListeMax = UBound(ListenArray)
Call QuickSort(0,ListeMax)	

'Skriptnamen eintragen
for n = 0 to ListeMax
	FF_SetControl "Deinstallation","Skriptname",ListenArray(n)
next

End Sub
'------------------------------------------------------------------------
Sub QuickSort(ByVal LB, ByVal UB)
'Sortieren des Arrays 'ListenArray' in das Array 'ListenArray'

Dim P1, P2, Ref, TEMP,FS

	FS = FS + 1
    P1 = LB
    P2 = UB
    Ref = ListenArray((P1 + P2) / 2)
    
    Do
        Do While ListenArray(P1) < Ref
            P1 = P1 + 1
        Loop
 
        Do While ListenArray(P2) > Ref
            P2 = P2 - 1
        Loop

        If P1 <= P2 Then
            TEMP = ListenArray(P1)
            ListenArray(P1) = ListenArray(P2)
            ListenArray(P2) = TEMP
           
            P1 = P1 + 1
            P2 = P2 - 1
        End If

    Loop Until P1 > P2

    If LB < P2 Then Call QuickSort(LB, P2)
    If P1 < UB Then Call QuickSort(P1, UB)

End Sub
'------------------------------------------------------------------------
Sub ArchivEntfernung
'Lschen aller zip-Archive im Skriptordner
Dim Ordner,Dateien,element,zipListe,n,msg,SPfad,CFile

'Prfung auf zip-Archive im Skriptordner
Set Ordner = objFS.GetFolder(FF_GetScriptPath)
Set Dateien = Ordner.Files
For Each element in Dateien
	if ucase(objFS.GetExtensionName(element)) = "ZIP" then
		if element <> objFS.GetBaseName(Skriptname) & ".zip" then	'Deinstallation.zip ausgenommen
			n = n + 1
			zipListe = zipListe & "@" & element
		end if
	end if
next

if n = 0 then exit sub
'Msgbox zipListe : Abbruch = true : exit sub
zipListe = mid(zipListe,2)
ListenArray = split(zipListe,"@")

if n = 1 then msg = "Das vorhandene zip-Archiv wird gelscht."
if n > 1 then msg = "Die vorhandenen " & n & " zip-Archive werden gelscht."

'Sicherung der zip-Archive
Antwort = msgbox(msg & vbNewLine & "Soll eine Sicherung vorgenommen werden?",vbYesNoCancel + vbQuestion,"Sicherheitsabfrage")
if Antwort = vbCancel then Abbruch = true : exit sub
if Antwort = vbYes then
	SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
	if SPfad = "" then
		msgbox "Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
		Abbruch = true
		exit sub
	end if
	
	'Sicherung
	For Each element in Listenarray
		CFile = SPfad & "\" & objFS.GetFileName(element)
		objFS.CopyFile element, CFile, true
	next
end if

'Lschen der zip-Archive
For Each element in Listenarray
	objFS.DeleteFile element,true
next

End Sub
'------------------------------------------------------------------------
Sub Skriptentfernung
'Entfernung des ausgwhlten Skripts im Skriptordner
Dim Zeile,tmpString,zNr

LoeschSkript = ucase("Name=" & LoeschSkript)
Set Zeile = objFS.OpenTextFile(IniDatei, ForReading)

do Until Zeile.AtEndOfStream
	tmpString = ucase(Zeile.ReadLine)
	zNr = zNr + 1
	if instr(tmpString,LoeschSkript) > 0 then
		tmpString = Zeile.ReadLine
		LoeschSkript = FF_GetScriptPath & mid(tmpString,7)
		EintragEnde = zNr + 1
	end if
loop 
Zeile.Close
objFS.DeleteFile LoeschSkript,true

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile,zNr,EintragAnfang,DateiTmp,tmpString,ZielZeile

EintragAnfang = EintragEnde - 3
DateiTmp = FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(IniDatei, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < EintragAnfang or zNr > EintragEnde then
		ZielZeile.WriteLine tmpString
	end if
loop

Zeile.Close
ZielZeile.Close

'Umkopieren von DateiTmp nach FixFotoScript.ini (IniDatei)
objFS.CopyFile DateiTmp,IniDatei, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen
Dim Archiv,SPfad

'zip-Archiv ggf. sichern und dann lschen
Archiv = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(Archiv) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Archiv, SPfad, true
	end if
	objFS.DeleteFile Archiv,true
end if

'Skriptdatei lschen
Loeschskript = objFS.GetBaseName(Skriptname)
call Skriptentfernung
call IniBereinigung

'Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
	 	Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------

